<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>DepPlanUtils xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../apidocs/org/eclipse/papyrus/designer/deployment/tools/DepPlanUtils.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2016 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *  Ansgar Radermacher  ansgar.radermacher@cea.fr</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.deployment.tools;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> java.util.Iterator;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.BasicEList;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.Enumerator;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.ENamedElement;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.deployment.profile.Deployment.DeploymentPlan;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.ElementUtils;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.utils.PackageUtil;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.utils.StereotypeUtil;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Class;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Classifier;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Enumeration;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.EnumerationLiteral;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.InstanceSpecification;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.InstanceValue;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.LiteralInteger;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.LiteralString;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Package;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Property;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Slot;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.StructuralFeature;
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.UMLPackage;
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.ValueSpecification;
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../org/eclipse/papyrus/designer/deployment/tools/DepPlanUtils.html">DepPlanUtils</a> {
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <em class="jxr_javadoccomment">	 * Return the package in which deployment plans are stored. Caveat: needs to be executed within a</em>
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <em class="jxr_javadoccomment">	 * transition, since the deployment plan package will be created, if it does not exist yet.</em>
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  <em class="jxr_javadoccomment">	 * @param element</em>
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  <em class="jxr_javadoccomment">	 *            an arbitrary element of the source model (i.e. the model that will</em>
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  <em class="jxr_javadoccomment">	 *            store the deployment plan</em>
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  <em class="jxr_javadoccomment">	 * @return package in which deployment plans are stored</em>
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Package getDepPlanRoot(Element element) {
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  		<strong class="jxr_keyword">return</strong> ElementUtils.getRoot(element, DeployConstants.depPlanFolder);
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  	}
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  <em class="jxr_javadoccomment">	 * Return all deployment plans</em>
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  <em class="jxr_javadoccomment">	 * @param element</em>
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  <em class="jxr_javadoccomment">	 *            an arbitrary element of the source model (i.e. the model that will</em>
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  <em class="jxr_javadoccomment">	 *            store the deployment plan</em>
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> EList&lt;Package&gt; getAllDepPlans(Element element) {
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  		Package root = PackageUtil.getRootPackage(element);
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  		Package depPlanRoot = root.getNestedPackage(DeployConstants.depPlanFolder);
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  		EList&lt;Package&gt; depPlanList = <strong class="jxr_keyword">new</strong> BasicEList&lt;Package&gt;();
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  		<strong class="jxr_keyword">if</strong> (depPlanRoot != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  			<strong class="jxr_keyword">for</strong> (Package pkg : depPlanRoot.getNestedPackages()) {
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  				<strong class="jxr_keyword">if</strong> (StereotypeUtil.isApplied(pkg, DeploymentPlan.<strong class="jxr_keyword">class</strong>)) {
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  					depPlanList.add(pkg);
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  				}
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  			}
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  		}
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  		<strong class="jxr_keyword">return</strong> depPlanList;
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  	}
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> delDepPlan(InstanceSpecification is) {
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  		Iterator&lt;Slot&gt; slots = is.getSlots().iterator();
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  		<strong class="jxr_keyword">while</strong> (slots.hasNext()) {
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  			Slot slot = slots.next();
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  			InstanceSpecification subInstance = getInstance(slot);
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  			<strong class="jxr_keyword">if</strong> (subInstance != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  				delDepPlan(subInstance);
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  			}
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  		}
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  		Element owner = is.getOwner();
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  		<strong class="jxr_keyword">if</strong> (owner instanceof Package) {
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  			((Package) owner).getPackagedElements().remove(is);
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  		}
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  	}
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  <em class="jxr_javadoccomment">	 * Return the instance that is defined by a slot value</em>
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  <em class="jxr_javadoccomment">	 * @param slot</em>
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  <em class="jxr_javadoccomment">	 * @return the first slot that corresponds to an instance specification</em>
<a class="jxr_linenumber" name="L100" href="#L100">100</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> InstanceSpecification getInstance(Slot slot) {
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 		Iterator&lt;ValueSpecification&gt; values = slot.getValues().iterator();
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 		<strong class="jxr_keyword">while</strong> (values.hasNext()) {
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 			ValueSpecification value = values.next();
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 			<em class="jxr_comment">// instances are accessible via ValueSpecification subclass InstanceValue</em>
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 			<strong class="jxr_keyword">if</strong> (value instanceof InstanceValue) {
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 				<strong class="jxr_keyword">return</strong> ((InstanceValue) value).getInstance();
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 			}
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 		}
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 	}
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L114" href="#L114">114</a> <em class="jxr_javadoccomment">	 * create a slot for a given sub-instance specification.</em>
<a class="jxr_linenumber" name="L115" href="#L115">115</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L116" href="#L116">116</a> <em class="jxr_javadoccomment">	 * @param cdp</em>
<a class="jxr_linenumber" name="L117" href="#L117">117</a> <em class="jxr_javadoccomment">	 *            a deployment plan</em>
<a class="jxr_linenumber" name="L118" href="#L118">118</a> <em class="jxr_javadoccomment">	 * @param is</em>
<a class="jxr_linenumber" name="L119" href="#L119">119</a> <em class="jxr_javadoccomment">	 *            an instance specification for a composite class</em>
<a class="jxr_linenumber" name="L120" href="#L120">120</a> <em class="jxr_javadoccomment">	 * @param partIS</em>
<a class="jxr_linenumber" name="L121" href="#L121">121</a> <em class="jxr_javadoccomment">	 *            the instance specification of a part within the composite</em>
<a class="jxr_linenumber" name="L122" href="#L122">122</a> <em class="jxr_javadoccomment">	 * @param part</em>
<a class="jxr_linenumber" name="L123" href="#L123">123</a> <em class="jxr_javadoccomment">	 *            the part within the composite</em>
<a class="jxr_linenumber" name="L124" href="#L124">124</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Slot createSlot(Package cdp, InstanceSpecification is, InstanceSpecification partIS, Property part) {
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 		<em class="jxr_comment">// the instance specification of the composite has a slot for each part and it points</em>
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 		<em class="jxr_comment">// to the instance specification associated with the part.</em>
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 		Slot slot = is.createSlot();
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 		slot.setDefiningFeature(part);
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 		InstanceValue iv = (InstanceValue)
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 				slot.createValue(<strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>, UMLPackage.eINSTANCE.getInstanceValue());
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 		iv.setInstance(partIS);
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 		<strong class="jxr_keyword">return</strong> slot;
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 	}
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L139" href="#L139">139</a> <em class="jxr_javadoccomment">	 * Automatically choose an implementation, i.e. choose the first implementation</em>
<a class="jxr_linenumber" name="L140" href="#L140">140</a> <em class="jxr_javadoccomment">	 * within the component model that implements a given component type.</em>
<a class="jxr_linenumber" name="L141" href="#L141">141</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L142" href="#L142">142</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Class autoChooseImplementation(Classifier componentType) {
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 		<em class="jxr_comment">// choose implementation automatically: get the first one that implements the passed type</em>
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 		<em class="jxr_comment">// (problem: further tree expansion might depend on chosen implementation)</em>
<a class="jxr_linenumber" name="L145" href="#L145">145</a> 		<em class="jxr_comment">// get reference to component model, then search all classes contained in it.</em>
<a class="jxr_linenumber" name="L146" href="#L146">146</a> 		Package compModel = ElementUtils.getRoot(componentType, DeployConstants.COMPONENT_MODEL);
<a class="jxr_linenumber" name="L147" href="#L147">147</a> 		Iterator&lt;Element&gt; elements = compModel.allOwnedElements().iterator();
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 		<strong class="jxr_keyword">while</strong> (elements.hasNext()) {
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 			Element element = elements.next();
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 			<strong class="jxr_keyword">if</strong> (element instanceof Class) {
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 				Class candidate = (Class) element;
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 				<strong class="jxr_keyword">if</strong> (candidate.getSuperClass(componentType.getName()) != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 					<strong class="jxr_keyword">return</strong> candidate;
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 				}
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 			}
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 		}
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 	}
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L161" href="#L161">161</a> <em class="jxr_javadoccomment">	 * Configure an attribute of an instance specification</em>
<a class="jxr_linenumber" name="L162" href="#L162">162</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L163" href="#L163">163</a> <em class="jxr_javadoccomment">	 * @param instance</em>
<a class="jxr_linenumber" name="L164" href="#L164">164</a> <em class="jxr_javadoccomment">	 *            the instance specification</em>
<a class="jxr_linenumber" name="L165" href="#L165">165</a> <em class="jxr_javadoccomment">	 * @param property</em>
<a class="jxr_linenumber" name="L166" href="#L166">166</a> <em class="jxr_javadoccomment">	 *            An ENamedElement denoting the name of an attribute of a classifier that</em>
<a class="jxr_linenumber" name="L167" href="#L167">167</a> <em class="jxr_javadoccomment">	 *            is in the classifier list of the instance specification</em>
<a class="jxr_linenumber" name="L168" href="#L168">168</a> <em class="jxr_javadoccomment">	 * @param value</em>
<a class="jxr_linenumber" name="L169" href="#L169">169</a> <em class="jxr_javadoccomment">	 *            the string value. An enumeration can be configured via the name of the literal</em>
<a class="jxr_linenumber" name="L170" href="#L170">170</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> configureProperty(InstanceSpecification instance, ENamedElement property, String value) {
<a class="jxr_linenumber" name="L172" href="#L172">172</a> 		configureProperty(instance, property.getName(), value);
<a class="jxr_linenumber" name="L173" href="#L173">173</a> 	}
<a class="jxr_linenumber" name="L174" href="#L174">174</a> 
<a class="jxr_linenumber" name="L175" href="#L175">175</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L176" href="#L176">176</a> <em class="jxr_javadoccomment">	 * Configure an attribute of an instance specification</em>
<a class="jxr_linenumber" name="L177" href="#L177">177</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L178" href="#L178">178</a> <em class="jxr_javadoccomment">	 * @param instance</em>
<a class="jxr_linenumber" name="L179" href="#L179">179</a> <em class="jxr_javadoccomment">	 *            the instance specification</em>
<a class="jxr_linenumber" name="L180" href="#L180">180</a> <em class="jxr_javadoccomment">	 * @param propertyName</em>
<a class="jxr_linenumber" name="L181" href="#L181">181</a> <em class="jxr_javadoccomment">	 *            the name of an attribute of a classifier that is in the classifier list</em>
<a class="jxr_linenumber" name="L182" href="#L182">182</a> <em class="jxr_javadoccomment">	 *            of the instance specification</em>
<a class="jxr_linenumber" name="L183" href="#L183">183</a> <em class="jxr_javadoccomment">	 * @param value</em>
<a class="jxr_linenumber" name="L184" href="#L184">184</a> <em class="jxr_javadoccomment">	 *            the string value. An enumeration can be configured via the name of the literal</em>
<a class="jxr_linenumber" name="L185" href="#L185">185</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L186" href="#L186">186</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> configureProperty(InstanceSpecification instance, String propertyName, String value) {
<a class="jxr_linenumber" name="L187" href="#L187">187</a> 		Classifier extension = DepUtils.getClassifier(instance);
<a class="jxr_linenumber" name="L188" href="#L188">188</a> 		Property attribute = (Property) ElementUtils.getNamedElementFromList(extension.getAllAttributes(), propertyName);
<a class="jxr_linenumber" name="L189" href="#L189">189</a> 		<strong class="jxr_keyword">if</strong> (attribute == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L190" href="#L190">190</a> 			<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> RuntimeException(String.format(Messages.DepPlanUtils_CannotFindAttribute, propertyName, extension.getName()));
<a class="jxr_linenumber" name="L191" href="#L191">191</a> 		}
<a class="jxr_linenumber" name="L192" href="#L192">192</a> 		configureProperty(instance, attribute, value);
<a class="jxr_linenumber" name="L193" href="#L193">193</a> 	}
<a class="jxr_linenumber" name="L194" href="#L194">194</a> 
<a class="jxr_linenumber" name="L195" href="#L195">195</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L196" href="#L196">196</a> <em class="jxr_javadoccomment">	 * Configure an attribute of an instance specification</em>
<a class="jxr_linenumber" name="L197" href="#L197">197</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L198" href="#L198">198</a> <em class="jxr_javadoccomment">	 * @param instance</em>
<a class="jxr_linenumber" name="L199" href="#L199">199</a> <em class="jxr_javadoccomment">	 *            the instance specification</em>
<a class="jxr_linenumber" name="L200" href="#L200">200</a> <em class="jxr_javadoccomment">	 * @param attribute</em>
<a class="jxr_linenumber" name="L201" href="#L201">201</a> <em class="jxr_javadoccomment">	 *            an attribute of a classifier that is in the classifier list of the instance specification</em>
<a class="jxr_linenumber" name="L202" href="#L202">202</a> <em class="jxr_javadoccomment">	 * @param value</em>
<a class="jxr_linenumber" name="L203" href="#L203">203</a> <em class="jxr_javadoccomment">	 *            the string value. An enumeration can be configured via the name of the literal</em>
<a class="jxr_linenumber" name="L204" href="#L204">204</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L205" href="#L205">205</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> configureProperty(InstanceSpecification instance, Property attribute, String value) {
<a class="jxr_linenumber" name="L206" href="#L206">206</a> 		<strong class="jxr_keyword">if</strong> (attribute.getType() instanceof Enumeration) {
<a class="jxr_linenumber" name="L207" href="#L207">207</a> 			configureEnumProperty(instance, attribute, value);
<a class="jxr_linenumber" name="L208" href="#L208">208</a> 		}
<a class="jxr_linenumber" name="L209" href="#L209">209</a> 		<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L210" href="#L210">210</a> 			<em class="jxr_comment">// create a slot for a string value</em>
<a class="jxr_linenumber" name="L211" href="#L211">211</a> 			Slot slotStringVal = DepCreation.createSlotForConfigProp(instance, attribute);
<a class="jxr_linenumber" name="L212" href="#L212">212</a> 			<strong class="jxr_keyword">if</strong> (slotStringVal.getValues().get(0) instanceof LiteralString) {
<a class="jxr_linenumber" name="L213" href="#L213">213</a> 				((LiteralString) slotStringVal.getValues().get(0)).setValue(value);
<a class="jxr_linenumber" name="L214" href="#L214">214</a> 			}
<a class="jxr_linenumber" name="L215" href="#L215">215</a> 			<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L216" href="#L216">216</a> 				<em class="jxr_comment">// indicates that operation has been called although types do not match</em>
<a class="jxr_linenumber" name="L217" href="#L217">217</a> 				<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> RuntimeException(String.format(Messages.DepPlanUtils_ConfigOfPropertyFailed, attribute.getName()));
<a class="jxr_linenumber" name="L218" href="#L218">218</a> 			}
<a class="jxr_linenumber" name="L219" href="#L219">219</a> 		}
<a class="jxr_linenumber" name="L220" href="#L220">220</a> 	}
<a class="jxr_linenumber" name="L221" href="#L221">221</a> 
<a class="jxr_linenumber" name="L222" href="#L222">222</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L223" href="#L223">223</a> <em class="jxr_javadoccomment">	 * Configure an attribute of an instance specification</em>
<a class="jxr_linenumber" name="L224" href="#L224">224</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L225" href="#L225">225</a> <em class="jxr_javadoccomment">	 * @param instance</em>
<a class="jxr_linenumber" name="L226" href="#L226">226</a> <em class="jxr_javadoccomment">	 *            the instance specification</em>
<a class="jxr_linenumber" name="L227" href="#L227">227</a> <em class="jxr_javadoccomment">	 * @param property</em>
<a class="jxr_linenumber" name="L228" href="#L228">228</a> <em class="jxr_javadoccomment">	 *            An ENamedElement denoting the name of an attribute of a classifier that</em>
<a class="jxr_linenumber" name="L229" href="#L229">229</a> <em class="jxr_javadoccomment">	 *            is in the classifier list of the instance specification</em>
<a class="jxr_linenumber" name="L230" href="#L230">230</a> <em class="jxr_javadoccomment">	 * @param value</em>
<a class="jxr_linenumber" name="L231" href="#L231">231</a> <em class="jxr_javadoccomment">	 *            the integer value.</em>
<a class="jxr_linenumber" name="L232" href="#L232">232</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L233" href="#L233">233</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> configureProperty(InstanceSpecification instance, ENamedElement property, <strong class="jxr_keyword">int</strong> value) {
<a class="jxr_linenumber" name="L234" href="#L234">234</a> 		configureProperty(instance, property.getName(), value);
<a class="jxr_linenumber" name="L235" href="#L235">235</a> 	}
<a class="jxr_linenumber" name="L236" href="#L236">236</a> 
<a class="jxr_linenumber" name="L237" href="#L237">237</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L238" href="#L238">238</a> <em class="jxr_javadoccomment">	 * Configure an attribute of an instance specification</em>
<a class="jxr_linenumber" name="L239" href="#L239">239</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L240" href="#L240">240</a> <em class="jxr_javadoccomment">	 * @param instance</em>
<a class="jxr_linenumber" name="L241" href="#L241">241</a> <em class="jxr_javadoccomment">	 *            the instance specification</em>
<a class="jxr_linenumber" name="L242" href="#L242">242</a> <em class="jxr_javadoccomment">	 * @param propertyName</em>
<a class="jxr_linenumber" name="L243" href="#L243">243</a> <em class="jxr_javadoccomment">	 *            the name of an attribute of a classifier that is in the classifier list</em>
<a class="jxr_linenumber" name="L244" href="#L244">244</a> <em class="jxr_javadoccomment">	 *            of the instance specification</em>
<a class="jxr_linenumber" name="L245" href="#L245">245</a> <em class="jxr_javadoccomment">	 * @param value</em>
<a class="jxr_linenumber" name="L246" href="#L246">246</a> <em class="jxr_javadoccomment">	 *            the integer value.</em>
<a class="jxr_linenumber" name="L247" href="#L247">247</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L248" href="#L248">248</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> configureProperty(InstanceSpecification instance, String propertyName, <strong class="jxr_keyword">int</strong> value) {
<a class="jxr_linenumber" name="L249" href="#L249">249</a> 		Classifier extension = DepUtils.getClassifier(instance);
<a class="jxr_linenumber" name="L250" href="#L250">250</a> 		Property attribute = (Property) ElementUtils.getNamedElementFromList(extension.getAllAttributes(), propertyName);
<a class="jxr_linenumber" name="L251" href="#L251">251</a> 		<strong class="jxr_keyword">if</strong> (attribute == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L252" href="#L252">252</a> 			<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> RuntimeException(String.format(Messages.DepPlanUtils_CannotFindAttribute, propertyName, extension.getName()));
<a class="jxr_linenumber" name="L253" href="#L253">253</a> 		}
<a class="jxr_linenumber" name="L254" href="#L254">254</a> 		configureProperty(instance, attribute, value);
<a class="jxr_linenumber" name="L255" href="#L255">255</a> 	}
<a class="jxr_linenumber" name="L256" href="#L256">256</a> 
<a class="jxr_linenumber" name="L257" href="#L257">257</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L258" href="#L258">258</a> <em class="jxr_javadoccomment">	 * Configure an attribute of an instance specification</em>
<a class="jxr_linenumber" name="L259" href="#L259">259</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L260" href="#L260">260</a> <em class="jxr_javadoccomment">	 * @param instance</em>
<a class="jxr_linenumber" name="L261" href="#L261">261</a> <em class="jxr_javadoccomment">	 *            the instance specification</em>
<a class="jxr_linenumber" name="L262" href="#L262">262</a> <em class="jxr_javadoccomment">	 * @param attribute</em>
<a class="jxr_linenumber" name="L263" href="#L263">263</a> <em class="jxr_javadoccomment">	 *            an attribute of a classifier that is in the classifier list of the instance specification</em>
<a class="jxr_linenumber" name="L264" href="#L264">264</a> <em class="jxr_javadoccomment">	 * @param value</em>
<a class="jxr_linenumber" name="L265" href="#L265">265</a> <em class="jxr_javadoccomment">	 *            the integer value.</em>
<a class="jxr_linenumber" name="L266" href="#L266">266</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L267" href="#L267">267</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> configureProperty(InstanceSpecification instance, Property attribute, <strong class="jxr_keyword">int</strong> value) {
<a class="jxr_linenumber" name="L268" href="#L268">268</a> 		Slot slotIntVal = instance.createSlot();
<a class="jxr_linenumber" name="L269" href="#L269">269</a> 		slotIntVal.setDefiningFeature(attribute);
<a class="jxr_linenumber" name="L270" href="#L270">270</a> 		LiteralInteger intValue = (LiteralInteger)
<a class="jxr_linenumber" name="L271" href="#L271">271</a> 				slotIntVal.createValue(<span class="jxr_string">"value for "</span> + attribute.getName(), attribute.getType(), UMLPackage.eINSTANCE.getLiteralInteger()); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L272" href="#L272">272</a> 		intValue.setValue(value);
<a class="jxr_linenumber" name="L273" href="#L273">273</a> 	}
<a class="jxr_linenumber" name="L274" href="#L274">274</a> 
<a class="jxr_linenumber" name="L275" href="#L275">275</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L276" href="#L276">276</a> <em class="jxr_javadoccomment">	 * Convenience function: allow that an ECore named element is passed instead of a property name. This is useful if the</em>
<a class="jxr_linenumber" name="L277" href="#L277">277</a> <em class="jxr_javadoccomment">	 * parameter that should be configured stems from a static profile</em>
<a class="jxr_linenumber" name="L278" href="#L278">278</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L279" href="#L279">279</a> <em class="jxr_javadoccomment">	 * @param instance</em>
<a class="jxr_linenumber" name="L280" href="#L280">280</a> <em class="jxr_javadoccomment">	 *            The instance of which an attribute should be configured.</em>
<a class="jxr_linenumber" name="L281" href="#L281">281</a> <em class="jxr_javadoccomment">	 * @param property</em>
<a class="jxr_linenumber" name="L282" href="#L282">282</a> <em class="jxr_javadoccomment">	 *            The name of the property (denoted by an ENamedElement) that should be configured</em>
<a class="jxr_linenumber" name="L283" href="#L283">283</a> <em class="jxr_javadoccomment">	 * @param value</em>
<a class="jxr_linenumber" name="L284" href="#L284">284</a> <em class="jxr_javadoccomment">	 *            its value in form of an element of an ECore enumerator value</em>
<a class="jxr_linenumber" name="L285" href="#L285">285</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L286" href="#L286">286</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> configureProperty(InstanceSpecification instance, ENamedElement property, Enumerator value) {
<a class="jxr_linenumber" name="L287" href="#L287">287</a> 		configureProperty(instance, property.getName(), value);
<a class="jxr_linenumber" name="L288" href="#L288">288</a> 	}
<a class="jxr_linenumber" name="L289" href="#L289">289</a> 
<a class="jxr_linenumber" name="L290" href="#L290">290</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L291" href="#L291">291</a> <em class="jxr_javadoccomment">	 * Configure a property for an enumeration. Enumerations are a bit difficult to handle, since the enumeration literal itself</em>
<a class="jxr_linenumber" name="L292" href="#L292">292</a> <em class="jxr_javadoccomment">	 * must be created first in form of an instance specification</em>
<a class="jxr_linenumber" name="L293" href="#L293">293</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L294" href="#L294">294</a> <em class="jxr_javadoccomment">	 * @param instance</em>
<a class="jxr_linenumber" name="L295" href="#L295">295</a> <em class="jxr_javadoccomment">	 *            The instance of which an attribute should be configured.</em>
<a class="jxr_linenumber" name="L296" href="#L296">296</a> <em class="jxr_javadoccomment">	 * @param propertyName</em>
<a class="jxr_linenumber" name="L297" href="#L297">297</a> <em class="jxr_javadoccomment">	 *            The name of the property that should be configured</em>
<a class="jxr_linenumber" name="L298" href="#L298">298</a> <em class="jxr_javadoccomment">	 * @param value</em>
<a class="jxr_linenumber" name="L299" href="#L299">299</a> <em class="jxr_javadoccomment">	 *            its value in form of an element of an ECore enumerator value</em>
<a class="jxr_linenumber" name="L300" href="#L300">300</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L301" href="#L301">301</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> configureProperty(InstanceSpecification instance, String propertyName, Enumerator value) {
<a class="jxr_linenumber" name="L302" href="#L302">302</a> 		configureProperty(instance, propertyName, value.getName());
<a class="jxr_linenumber" name="L303" href="#L303">303</a> 	}
<a class="jxr_linenumber" name="L304" href="#L304">304</a> 
<a class="jxr_linenumber" name="L305" href="#L305">305</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L306" href="#L306">306</a> <em class="jxr_javadoccomment">	 * Configure a property for an enumeration. Enumerations are a bit difficult to handle, since the enumeration literal itself</em>
<a class="jxr_linenumber" name="L307" href="#L307">307</a> <em class="jxr_javadoccomment">	 * must be created first in form of an instance specification.</em>
<a class="jxr_linenumber" name="L308" href="#L308">308</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L309" href="#L309">309</a> <em class="jxr_javadoccomment">	 * @param instance</em>
<a class="jxr_linenumber" name="L310" href="#L310">310</a> <em class="jxr_javadoccomment">	 *            The instance of which an attribute should be configured.</em>
<a class="jxr_linenumber" name="L311" href="#L311">311</a> <em class="jxr_javadoccomment">	 * @param propertyName</em>
<a class="jxr_linenumber" name="L312" href="#L312">312</a> <em class="jxr_javadoccomment">	 *            The name of the property that should be configured</em>
<a class="jxr_linenumber" name="L313" href="#L313">313</a> <em class="jxr_javadoccomment">	 * @param value</em>
<a class="jxr_linenumber" name="L314" href="#L314">314</a> <em class="jxr_javadoccomment">	 *            its value in form of an String. The function does nothing, if no literal corresponds to the passed</em>
<a class="jxr_linenumber" name="L315" href="#L315">315</a> <em class="jxr_javadoccomment">	 *            String</em>
<a class="jxr_linenumber" name="L316" href="#L316">316</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L317" href="#L317">317</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> configureEnumProperty(InstanceSpecification instance, String propertyName, String literalName) {
<a class="jxr_linenumber" name="L318" href="#L318">318</a> 		Classifier extension = DepUtils.getClassifier(instance);
<a class="jxr_linenumber" name="L319" href="#L319">319</a> 		Property attribute = (Property) ElementUtils.getNamedElementFromList(extension.getAllAttributes(), propertyName);
<a class="jxr_linenumber" name="L320" href="#L320">320</a> 		<strong class="jxr_keyword">if</strong> (attribute == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L321" href="#L321">321</a> 			<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> RuntimeException(String.format(Messages.DepPlanUtils_CannotFindAttribute, propertyName, extension.getName()));
<a class="jxr_linenumber" name="L322" href="#L322">322</a> 		}
<a class="jxr_linenumber" name="L323" href="#L323">323</a> 		configureEnumProperty(instance, attribute, literalName);
<a class="jxr_linenumber" name="L324" href="#L324">324</a> 	}
<a class="jxr_linenumber" name="L325" href="#L325">325</a> 
<a class="jxr_linenumber" name="L326" href="#L326">326</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> configureEnumProperty(InstanceSpecification instance, Property attribute, String literalName) {
<a class="jxr_linenumber" name="L327" href="#L327">327</a> 		<strong class="jxr_keyword">if</strong> (attribute.getType() instanceof Enumeration) {
<a class="jxr_linenumber" name="L328" href="#L328">328</a> 			Enumeration enumeration = (Enumeration) attribute.getType();
<a class="jxr_linenumber" name="L329" href="#L329">329</a> 			<strong class="jxr_keyword">for</strong> (EnumerationLiteral enumLiteral : enumeration.getOwnedLiterals()) {
<a class="jxr_linenumber" name="L330" href="#L330">330</a> 				<strong class="jxr_keyword">if</strong> (enumLiteral.getLabel().equals(literalName)) {
<a class="jxr_linenumber" name="L331" href="#L331">331</a> 					Slot slotEnumVal = instance.createSlot();
<a class="jxr_linenumber" name="L332" href="#L332">332</a> 					slotEnumVal.setDefiningFeature(attribute);
<a class="jxr_linenumber" name="L333" href="#L333">333</a> 					InstanceValue enumLitValue = (InstanceValue)
<a class="jxr_linenumber" name="L334" href="#L334">334</a> 							slotEnumVal.createValue(<span class="jxr_string">"value for "</span> + attribute.getName(), attribute.getType(), UMLPackage.eINSTANCE.getInstanceValue()); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L335" href="#L335">335</a> 					enumLitValue.setInstance(enumLiteral);
<a class="jxr_linenumber" name="L336" href="#L336">336</a> 					<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L337" href="#L337">337</a> 				}
<a class="jxr_linenumber" name="L338" href="#L338">338</a> 			}
<a class="jxr_linenumber" name="L339" href="#L339">339</a> 		}
<a class="jxr_linenumber" name="L340" href="#L340">340</a> 	}
<a class="jxr_linenumber" name="L341" href="#L341">341</a> 
<a class="jxr_linenumber" name="L342" href="#L342">342</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L343" href="#L343">343</a> <em class="jxr_javadoccomment">	 * Update the names of instances within a deployment plan to correspond to changes</em>
<a class="jxr_linenumber" name="L344" href="#L344">344</a> <em class="jxr_javadoccomment">	 * in the hierarchy. In particular, flattening of interaction components requires this update.</em>
<a class="jxr_linenumber" name="L345" href="#L345">345</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L346" href="#L346">346</a> <em class="jxr_javadoccomment">	 * @param composite</em>
<a class="jxr_linenumber" name="L347" href="#L347">347</a> <em class="jxr_javadoccomment">	 *            System composite</em>
<a class="jxr_linenumber" name="L348" href="#L348">348</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L349" href="#L349">349</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> updateInstanceNames(InstanceSpecification instance, String name) {
<a class="jxr_linenumber" name="L350" href="#L350">350</a> 		instance.setName(name);
<a class="jxr_linenumber" name="L351" href="#L351">351</a> 		<strong class="jxr_keyword">for</strong> (Slot slot : instance.getSlots()) {
<a class="jxr_linenumber" name="L352" href="#L352">352</a> 			InstanceSpecification subInstance = DepUtils.getInstance(slot);
<a class="jxr_linenumber" name="L353" href="#L353">353</a> 			StructuralFeature sf = slot.getDefiningFeature();
<a class="jxr_linenumber" name="L354" href="#L354">354</a> 			<strong class="jxr_keyword">if</strong> ((subInstance != <strong class="jxr_keyword">null</strong>) &amp;&amp; !DepUtils.isShared(slot)) {
<a class="jxr_linenumber" name="L355" href="#L355">355</a> 				updateInstanceNames(subInstance, name + DeployConstants.SEP_CHAR + sf.getName());
<a class="jxr_linenumber" name="L356" href="#L356">356</a> 			}
<a class="jxr_linenumber" name="L357" href="#L357">357</a> 		}
<a class="jxr_linenumber" name="L358" href="#L358">358</a> 	}
<a class="jxr_linenumber" name="L359" href="#L359">359</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
